﻿#requires -version 3.0

[cmdletbinding()]

Param()

Write-Verbose "$(Get-Date) Starting script"

Write-Host "This is a demo script" -ForegroundColor Green

#a collection of computer names, some bogus and some with no permissions
$comp="client2","foo","jdhit-dc01","coredc01"

foreach ($c in $comp) {

    Write-Verbose "$(Get-Date) Testing connection to $c"
    #ping the computer
    if (Test-Connection $c -quiet -count 1) {
     Write-Verbose "$(Get-Date) Finished testing connection"
     Try {
       Get-WmiObject win32_operatingsystem -comp $c -ea Stop | Select CSName,Caption,Version
    }

    Catch {
        $msg="!!!WMI failed on $c. $($_.Exception.message)!!!"
        Write-Warning $msg
        $_ | Select * | Write-Error
    }
}
    else {
       Write-Warning "$(Get-Date)Failed to ping $c"
       Write-Verbose "$(Get-Date) Finished testing"
}

} #foreach

Write-Verbose "$(Get-Date) Ending script"
